#include <stdio.h>
#include <stdlib.h>
#include <omp.h>

#define N 16384
int A[N][N], A_T[N][N];

// TODO CHANGE THIS CODE
void transpose(void) {
  #pragma omp parallel for 
  for (int i = 0; i < N; i++) {
    for (int j = 0; j < N; j++) {
      A_T[i][j] = A[j][i];
    }
  }
}

void init() { 
  #pragma omp parallel for 
  for (int i = 0; i < N; i++) {
    for (int j = 0; j < N; j++) {
      A[i][j] = i + j;
    }
  }
}

int main(int argc, char** argv) {
  --argc; ++argv;

  if (argc != 1) {
    printf("Usage: mtrans.bin n_threads\n");
    return 1;
  }

  int n_threads =  atoi(argv[0]);

  if (n_threads <= 0) {
    printf("Invalid number of threads: %s\n", argv[0]);
    return 1;
  }

  omp_set_num_threads(n_threads);

  init();
  double t = - omp_get_wtime();
  transpose();
  t += omp_get_wtime();
  printf("Time (s): %.3f\n", t);

  return 0;
}
