#include <stdio.h>
#include <stdlib.h>
#include <omp.h>

#define N 100000000
int A[N], B[N], C[N];

// TODO CHANGE THIS CODE
void add(void) {
  #pragma omp parallel for
  for (int i = 0; i < N; i++) {
    C[i] = A[i] + B[i];
  }
}

void init() { 
  #pragma omp parallel for 
  for (int i = 0; i < N; i++) {
      A[i] = i; 
      B[i] = i; 
  }
}

int main(int argc, char** argv) {
  --argc; ++argv;

  if (argc != 1) {
    printf("Usage: vadd.bin n_threads\n");
    return 1;
  }

  int n_threads =  atoi(argv[0]);

  if (n_threads <= 0) {
    printf("Invalid number of threads: %s\n", argv[0]);
    return 1;
  }

  omp_set_num_threads(n_threads);

  init();
  double t = - omp_get_wtime();
  add();
  t += omp_get_wtime();
  printf("Time (s): %.3f\n", t);

  return 0;
}
